Index: trunk/examples/extended/electromagnetic/TestEm7/include/c2_function.icc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm7/include/c2_function.icc	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm7/include/c2_function.icc	(revision 1230)
@@ -985,78 +1219,333 @@
 			float_type y0=tail(x0);
 			float_type y1=func(x1);
-			c2_function<float_type> *connector=new c2_linear<float_type>(x0, y0, (y1-y0)/(x1-x0));
-			connector->set_domain(x0,x1);
-			functions.push_back(connector);
-			owns.push_back(true);
+			c2_function<float_type> &connector=*new c2_linear_p<float_type>(x0, y0, (y1-y0)/(x1-x0));
+			connector.set_domain(x0,x1);
+			functions.push_back(c2_const_ptr<float_type>(connector));
 			this->sampling_grid->push_back(x1);
 		} else if(x0>x1) throw c2_exception("function domains not increasing in c2_piecewise_function");
 	}
-	functions.push_back(&func);
-	owns.push_back(pass_ownership);
+	functions.push_back(keepfunc);
 	// extend our domain to include all known functions
 	this->set_domain(functions.front()->xmin(), functions.back()->xmax());
 	// extend our sampling grid with the new function's grid, with the first point dropped to avoid duplicates
-	std::vector<float_type> &newgrid=func.get_sampling_grid(func.xmin(), func.xmax());
+	std::vector<float_type> newgrid;
+	func.get_sampling_grid(func.xmin(), func.xmax(), newgrid);
 	this->sampling_grid->insert(this->sampling_grid->end(), newgrid.begin()+1, newgrid.end());
-	delete &newgrid;
-}
-
-template <typename float_type> c2_connector_function<float_type>::c2_connector_function(
-	const c2_function<float_type> &f1, const c2_function<float_type> &f2, float_type x0, float_type x2, 
+}
+
+template <typename float_type> c2_connector_function_p<float_type>::c2_connector_function_p(
+	float_type x0, const c2_function<float_type> &f0, float_type x2, const c2_function<float_type> &f2, 
 	bool auto_center, float_type y1)
-
-: c2_function<float_type>()
-{
-	float_type y0, yp0, ypp0, y2, yp2, ypp2;
-	fdx=(x2-x0)/2.0;
-	fhinv=1.0/fdx;
-	fx1=(x0+x2)/2.0;
-	
-	y0=f1.value_with_derivatives(x0, &yp0, &ypp0); // get left wall values from conventional computation
-	y2=f2.value_with_derivatives(x2, &yp2, &ypp2); // get right wall values from conventional computation
+	: c2_function<float_type>()
+{
+	c2_const_ptr<float_type> left(f0), right(f2); // make sure if these are unowned, they get deleted
+	c2_fblock<float_type> fb0, fb2;
+	fb0.x=x0;
+	f0.fill_fblock(fb0);
+	fb2.x=x2;
+	f2.fill_fblock(fb2);
+	init(fb0, fb2, auto_center, y1);
+}
+
+template <typename float_type> c2_connector_function_p<float_type>::c2_connector_function_p(
+	float_type x0, float_type y0, float_type yp0, float_type ypp0, 
+	float_type x2, float_type y2, float_type yp2, float_type ypp2, 
+	bool auto_center, float_type y1)
+	: c2_function<float_type>()
+{
+	c2_fblock<float_type> fb0, fb2;
+	fb0.x=x0; fb0.y=y0; fb0.yp=yp0; fb0.ypp=ypp0;
+	fb2.x=x2; fb2.y=y2; fb2.yp=yp2; fb2.ypp=ypp2;	
+	init(fb0, fb2, auto_center, y1);
+}
+
+template <typename float_type> c2_connector_function_p<float_type>::c2_connector_function_p(
+	const c2_fblock<float_type> &fb0,
+	const c2_fblock<float_type> &fb2,
+	bool auto_center, float_type y1)
+	: c2_function<float_type>()
+{
+	init(fb0, fb2, auto_center, y1);
+}
+
+template <typename float_type> void c2_connector_function_p<float_type>::init(
+	const c2_fblock<float_type> &fb0,
+	const c2_fblock<float_type> &fb2,
+	bool auto_center, float_type y1)
+{
+	float_type dx=(fb2.x-fb0.x)/2.0;
+	fhinv=1.0/dx;
 
 	// scale derivs to put function on [-1,1] since mma  solution is done this way
-	yp0*=fdx;
-	yp2*=fdx;
-	ypp0*=fdx*fdx;
-	ypp2*=fdx*fdx;
-	
-	float_type ff0=(8*(y0 + y2) + 5*(yp0 - yp2) + ypp0 + ypp2)/16.0;
+	float_type yp0=fb0.yp*dx;
+	float_type yp2=fb2.yp*dx;
+	float_type ypp0=fb0.ypp*dx*dx;
+	float_type ypp2=fb2.ypp*dx*dx;
+	
+	float_type ff0=(8*(fb0.y + fb2.y) + 5*(yp0 - yp2) + ypp0 + ypp2)*0.0625;
 	if(auto_center) y1=ff0; // forces ff to be 0 if we are auto-centering
 	
-	// y[x_] = y1 + x (a + b x) + (x-1) x (x+1) (c + d x + e x^2 + f x^3)
+	// y[x_] = y1 + x (a + b x) + x [(x-1) (x+1)] (c + d x) + x (x-1)^2 (x+1)^2 (e + f x)
+	// y' = a + 2 b x + d x [(x+1)(x-1)] + (c + d x)(3x^2-1) + f x [(x+1)(x-1)]^2 + (e + f x)[(x+1)(x-1)](5x^2-1)  
+	// y'' = 2 b + 6x(c + d x) + 2d(3x^2-1) + 4x(e + f x)(5x^2-3) + 2f(x^2-1)(5x^2-1)
 	fy1=y1; 
-	fa=-(y0 - y2)/2.;
-	fb=(y0 - 2*y1 + y2)/2.;
-	fc=(7*(y0 - y2 + yp0 + yp2) + ypp0 - ypp2)/16.;
-	fd=(32*y1 - 16*(y2 + y0) + 9*(yp2 - yp0) - ypp0 - ypp2)/16.;
-	fe=(3*(y2 - y0 - yp0 - yp2) - ypp0 + ypp2)/16.;
+	fa=(fb2.y - fb0.y)*0.5;
+	fb=(fb0.y + fb2.y)*0.5 - y1;
+	fc=(yp2+yp0-2.*fa)*0.25;
+	fd=(yp2-yp0-4.*fb)*0.25;
+	fe=(ypp2-ypp0-12.*fc)*0.0625;
 	ff=(ff0 - y1);
-	// y'[x] = a + 2 b x + (3x^2 - 1)   (c + d x + e x^2 + f x^3) + (x-1) x (x+1) (d + 2 e x + 3 f x^2 )
-	// y''[x] = 2b + (x-1) x (x+1) (2 e + 6 f x) + 2 (3 x^2 -1) (d + 2 e x + 3 f x^2 ) + 6 x (c + d x + e x^2 + f x^3)
-	this->set_domain(x0,x2); // this is where the function is valid
-}
-
-template <typename float_type> c2_connector_function<float_type>::~c2_connector_function() 
-{
-}
-
-template <typename float_type> float_type c2_connector_function<float_type>::value_with_derivatives(
+	this->set_domain(fb0.x, fb2.x); // this is where the function is valid
+}
+
+template <typename float_type> c2_connector_function_p<float_type>::~c2_connector_function_p() 
+{
+}
+
+template <typename float_type> float_type c2_connector_function_p<float_type>::value_with_derivatives(
 	float_type x, float_type *yprime, float_type *yprime2
 	) const throw(c2_exception)
 {
-																									
-	float_type dx=(x-fx1)*fhinv;
-	float_type q1=fc + dx*(fd + dx*(fe + dx*ff));
-	float_type xp1=(dx-1)*(dx+1)*dx;
-	
-	float_type y= fy1 + dx*(fa+fb*dx) + xp1*q1;
+	float_type x0=this->xmin(), x2=this->xmax();
+	float_type dx=(x-(x0+x2)*0.5)*fhinv;
+	float_type q1=(x-x0)*(x-x2)*fhinv*fhinv; // exactly vanish all bits at both ends
+	float_type q2=dx*q1;
+	
+	float_type r1=fa+fb*dx;
+	float_type r2=fc+fd*dx;
+	float_type r3=fe+ff*dx;
+	
+	float_type y=fy1+dx*r1+q2*r2+q1*q2*r3;
+	
 	if(yprime || yprime2) {
-		float_type q2 =fd + dx*(2*fe + dx*3*ff);	
-		float_type q3=2*fe+6*ff*dx;
-		float_type xp2=(3*dx*dx-1);
-		if(yprime) *yprime=(fa + 2*fb*dx + xp2*q1 + xp1*q2)*fhinv;
-		if(yprime2) *yprime2=(2*fb+xp1*q3+2*xp2*q2+6*dx*q1)*fhinv*fhinv;
+		float_type q3=3*q1+2;
+		float_type q4=5*q1+4;
+		if(yprime) *yprime=(fa+2*fb*dx+fd*q2+r2*q3+ff*q1*q2+q1*q4*r3)*fhinv;
+		if(yprime2) *yprime2=2*(fb+fd*q3+3*dx*r2+ff*q1*q4+r3*(2*dx*(5*q1+2)))*fhinv*fhinv;
 	}
 	return y;
 }
+
+// the recursive part of the sampler is agressively designed to minimize copying of data... lots of pointers
+template <typename float_type> void c2_function<float_type>::sample_step(c2_sample_recur &rb) const throw(c2_exception)
+{
+	std::vector< recur_item > &rb_stack=*rb.rb_stack; // heap-based stack of data for recursion
+	rb_stack.clear();
+	
+	recur_item top;
+	top.depth=0; top.done=false; top.f0index=0; top.f2index=0;
+	
+	// push storage for our initial elements
+	rb_stack.push_back(top);
+	rb_stack.back().f1=*rb.f0;
+	rb_stack.back().done=true;
+
+	rb_stack.push_back(top);
+	rb_stack.back().f1=*rb.f1;
+	rb_stack.back().done=true;
+	
+	if(!rb.inited) {
+		rb.dx_tolerance=10.0*std::numeric_limits<float_type>::epsilon();
+		rb.abs_tol_min=10.0*std::numeric_limits<float_type>::min();
+		rb.inited=true;
+	}
+
+	// now, push our first real element
+	top.f0index=0; // left element is stack[0]
+	top.f2index=1; // right element is stack[1]
+	rb_stack.push_back(top);
+
+	while(rb_stack.size() > 2) {
+		recur_item &back=rb_stack.back();
+		if(back.done) {
+			rb_stack.pop_back();
+			continue;
+		}
+		back.done=true;
+
+		c2_fblock<float_type> &f0=rb_stack[back.f0index].f1, &f2=rb_stack[back.f2index].f1; 
+		c2_fblock<float_type> &f1=back.f1; // will hold new middle values
+		size_t f1index=rb_stack.size()-1; // our current offset
+
+		// std::cout << "processing: " << rb_stack.size() << " " << 
+		// (&back-&rb_stack.front())  << " " << back.depth << " " << f0.x << " " << f2.x << std::endl;
+
+		f1.x=0.5*(f0.x + f2.x); // center of interval
+		float_type dx2=0.5*(f2.x - f0.x);
+			
+		// check for underflow on step size, which prevents us from achieving specified accuracy. 
+		if(std::abs(dx2) < std::abs(f1.x)*rb.dx_tolerance || std::abs(dx2) < rb.abs_tol_min) {
+			std::ostringstream outstr;
+			outstr << "Step size underflow in adaptive_sampling at depth=" << back.depth << ", x= " << f1.x;
+			throw c2_exception(outstr.str().c_str());
+		}
+		
+		fill_fblock(f1);
+		
+		if(c2_isnan(f1.y) || f1.ypbad || f1.yppbad) {
+			// can't go any further if a nan has appeared
+			bad_x_point=f1.x;
+			throw c2_exception("NaN encountered while sampling function"); 
+		}
+
+		float_type eps; 
+		if(rb.derivs==2) {
+			// this is code from connector_function to compute the value at the midpoint
+			// it is re-included here to avoid constructing a complete c2connector
+			// just to find out if we are close enough
+			float_type ff0=(8*(f0.y + f2.y) + 5*(f0.yp - f2.yp)*dx2 + (f0.ypp+f2.ypp)*dx2*dx2)*0.0625;
+			// we are converging as at least x**5 and bisecting, so real error on final step is smaller
+			eps=std::abs(ff0-f1.y)/32.0;   
+		} else {
+			// there are two tolerances to meet... the shift in the estimate of the actual point,
+			// and the difference between the current points and the extremum
+			// build all the coefficients needed to construct the local parabola
+			float_type ypcenter, ypp;
+			if (rb.derivs==1) {
+				// linear extrapolation error using exact derivs
+				eps = (std::abs(f0.y+f0.yp*dx2-f1.y)+std::abs(f2.y-f2.yp*dx2-f1.y))*0.125; 
+				ypcenter=2*f1.yp*dx2; // first deriv scaled so this interval is on [-1,1]
+				ypp=2*(f2.yp-f0.yp)*dx2*dx2; // second deriv estimate scaled so this interval is on [-1,1]
+			} else {
+				// linear interpolation error without derivs if we are at top level
+				//  or 3-point parabolic interpolation estimates from previous level, if available
+				ypcenter=(f2.y-f0.y)*0.5; // derivative estimate at center
+				ypp=(f2.y+f0.y-2*f1.y); // second deriv estimate
+				if(back.depth==0) eps=std::abs((f0.y+f2.y)*0.5 - f1.y)*2; // penalize first step
+				else eps=std::abs(f1.y-back.previous_estimate)*0.25; 
+			}
+			float_type ypleft=ypcenter-ypp; // derivative at left edge
+			float_type ypright=ypcenter+ypp; // derivative at right edge
+			float_type extremum_eps=0;
+			if((ypleft*ypright) <=0) // y' changes sign if we have an extremum
+			{
+				// compute position and value of the extremum this way
+				float_type xext=-ypcenter/ypp;
+				float_type yext=f1.y + xext*ypcenter + 0.5*xext*xext*ypp;
+				// and then find the the smallest offset of it from a point, looking in the left or right side
+				if(xext <=0) extremum_eps=std::min(std::abs(f0.y-yext), std::abs(f1.y-yext));
+				else extremum_eps=std::min(std::abs(f2.y-yext), std::abs(f1.y-yext));
+			}
+			eps=std::max(eps, extremum_eps); // if previous shot was really bad, keep trying
+		}
+		
+		if(eps < rb.abs_tol ||  eps < std::abs(f1.y)*rb.rel_tol) {
+			if(rb.out) {
+				// we've met the tolerance, and are building a function, append two connectors
+				rb.out->append_function(
+					*new c2_connector_function_p<float_type>(f0, f1, true, 0.0)
+				);
+				rb.out->append_function(
+					*new c2_connector_function_p<float_type>(f1, f2, true, 0.0)
+				);
+			}
+			if(rb.xvals && rb.yvals) {
+				rb.xvals->push_back(f0.x);
+				rb.xvals->push_back(f1.x);
+				rb.yvals->push_back(f0.y);
+				rb.yvals->push_back(f1.y);
+				// the value at f2 will get pushed in the next segment... it is not forgotten
+			}
+		} else {
+			top.depth=back.depth+1; // increment depth counter
+
+			// save the last things we need from back before a push happens, in case 
+			// the push causes a reallocation and moves the whole stack.
+			size_t f0index=back.f0index, f2index=back.f2index;
+			float_type left=0, right=0;
+			if(rb.derivs==0) {
+				// compute three-point parabolic interpolation estimate of right-hand and left-hand midpoint
+				left=(6*f1.y + 3*f0.y - f2.y) * 0.125;
+				right=(6*f1.y + 3*f2.y - f0.y) * 0.125; 
+			}
+			
+			top.f0index=f1index; top.f2index=f2index; // insert pointers to right side data into our recursion block			
+			top.previous_estimate=right; 
+			rb_stack.push_back(top);
+
+			top.f0index=f0index; top.f2index=f1index; // insert pointers to left side data into our recursion block
+			top.previous_estimate=left; 
+			rb_stack.push_back(top);
+		}
+	}
+}
+
+template <typename float_type>  c2_piecewise_function_p<float_type> *
+	c2_function<float_type>::adaptively_sample(
+		float_type xmin, float_type xmax,
+		float_type abs_tol, float_type rel_tol,
+		int derivs, std::vector<float_type> *xvals, std::vector<float_type> *yvals) const throw(c2_exception)
+{
+	c2_fblock<float_type> f0, f2;
+	c2_sample_recur rb;
+	std::vector< recur_item > rb_stack;
+	rb_stack.reserve(20); // enough for most operations
+	rb.rb_stack=&rb_stack;
+	rb.out=0;
+	if(derivs==2) rb.out=new c2_piecewise_function_p<float_type>();
+	c2_ptr<float_type> pieces(*rb.out); // manage this function, if any, so it deletes on an exception
+	rb.rel_tol=rel_tol;
+	rb.abs_tol=abs_tol;
+	rb.xvals=xvals;
+	rb.yvals=yvals;
+	rb.derivs=derivs;
+	rb.inited=false;
+	
+	if(xvals && yvals) {
+		xvals->clear();
+		yvals->clear();
+	}
+	 
+	// create xgrid as a automatic-variable copy of the sampling grid so the exception handler correctly 
+	// disposes of it.
+	std::vector<float_type> xgrid;
+	get_sampling_grid(xmin, xmax, xgrid);
+	int np=xgrid.size();	 
+
+	f2.x=xgrid[0];
+	fill_fblock(f2);
+	if(c2_isnan(f2.y) || f2.ypbad || f2.yppbad) {
+		// can't go any further if a nan has appeared
+		bad_x_point=f2.x;
+		throw c2_exception("NaN encountered while sampling function"); 
+	}
+
+	for(int i=0; i<np-1; i++) {
+		f0=f2; // copy upper bound to lower before computing new upper bound
+
+		f2.x=xgrid[i+1];
+		fill_fblock(f2);
+		if(c2_isnan(f2.y) || f2.ypbad || f2.yppbad) {
+			// can't go any further if a nan has appeared
+			bad_x_point=f2.x;
+			throw c2_exception("NaN encountered while sampling function"); 
+		}
+
+		rb.f0=&f0; rb.f1=&f2;
+		sample_step(rb);
+	}
+	if(xvals && yvals) { // push final point in vector
+		xvals->push_back(f2.x);
+		yvals->push_back(f2.y);
+	}
+	
+	if(rb.out) rb.out->set_sampling_grid(xgrid); // reflect old sampling grid, which still should be right
+	pieces.release_for_return(); // unmanage the piecewise_function so we can return it
+	return rb.out;
+}
+
+template <typename float_type, typename Final> 
+ interpolating_function_p<float_type> & inverse_integrated_density_function(
+	const std::vector<float_type> &bincenters, const c2_function<float_type> &binheights)
+	throw(c2_exception)
+{	
+	return (new Final())->load_random_generator_function(bincenters, binheights);
+}
+
+template <typename float_type, typename Final> 
+	interpolating_function_p<float_type> & inverse_integrated_density_bins(
+	const std::vector<float_type> &bins, const std::vector<float_type> &binheights)
+	throw(c2_exception)
+{	
+	return (new Final())->load_random_generator_bins(bins, binheights);
+}
Index: trunk/examples/extended/electromagnetic/TestEm7/ionC12.mac
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm7/ionC12.mac	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm7/ionC12.mac	(revision 1230)
@@ -1,3 +1,3 @@
-# $Id: ionC12.mac,v 1.19 2007/11/07 19:41:32 vnivanch Exp $
+# $Id: ionC12.mac,v 1.22 2008/10/24 15:36:24 maire Exp $
 #
 # Macro file for "TestEm7.cc"
@@ -7,11 +7,11 @@
 /control/verbose 2
 /run/verbose 2
-/tracking/verbose 1
+/tracking/verbose 0
 #
-/testem/det/setMat Water
+/testem/det/setMat G4_WATER
 /testem/det/setSizeX  20 cm
 /testem/det/setSizeYZ 20 cm
 #
-/testem/det/tallyMat Water
+/testem/det/tallyMat G4_WATER
 /testem/det/tallySize 2. 2. 2. mm
 /testem/det/tallyPosition -9.9 0. 0. cm
@@ -20,7 +20,7 @@
 /testem/det/tallyPosition  5.  0. 0. cm
 #
-/testem/phys/addPhysics  standardNR	
-#/testem/phys/addPhysics  emstandard
-#/testem/phys/addPhysics  standard_opt2
+#/testem/phys/addPhysics  standardNR	
+/testem/phys/addPhysics  emstandard
+#/testem/phys/addPhysics  emstandard_opt2
 #
 /run/initialize
@@ -29,13 +29,19 @@
 /gun/ion 6 12 6
 #/gun/ion 6 12 1
-/gun/energy 3.5 GeV
+/gun/energy 2.4 GeV
 #
 # beam size
-/testem/gun/rndm 2 mm
+#/testem/gun/rndm 2 mm
 #
 # step limit
-/testem/stepMax 1 mm
+/testem/phys/setCuts 0.5 mm
+#/testem/stepMax 0.1 mm
 #
 /testem/event/printModulo 1000
 #
+/testem/histo/fileName c12
+/testem/histo/fileType root
+/testem/histo/setHisto 1 100 80 90
+/testem/histo/setHisto 2 100 80 90
+#
 /run/beamOn 1000
Index: trunk/examples/extended/electromagnetic/TestEm7/proton.mac
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm7/proton.mac	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm7/proton.mac	(revision 1230)
@@ -1,3 +1,3 @@
-# $Id: proton.mac,v 1.10 2007/07/28 16:39:31 vnivanch Exp $
+# $Id: proton.mac,v 1.17 2008/10/24 15:36:24 maire Exp $
 #
 # Macro file for "TestEm7.cc"
@@ -8,9 +8,11 @@
 /run/verbose 2
 #
-/testem/det/setMat Water
+/testem/det/setMat G4_WATER
 /testem/det/setSizeX  10 cm
 /testem/det/setSizeYZ 10 cm
+/testem/det/tallyMat G4_WATER
 #
-/testem/phys/addPhysics  standard	#em physics
+#/testem/phys/addPhysics  standard
+/testem/phys/addPhysics  emstandard_opt3
 #
 /run/initialize
@@ -20,7 +22,15 @@
 #
 # step limit
-/testem/stepMax 0.5 mm
+#/testem/phys/setCuts 0.5 mm
+/testem/phys/setCuts 1 mm
+#/testem/stepMax 0.5 mm
 #
 /testem/event/printModulo 1000
 #
+/testem/histo/fileName p100opt3cut1
+/testem/histo/fileType root
+/testem/histo/setHisto 1 100 70 80
+/testem/histo/setHisto 2 100 70 80
+#
 /run/beamOn 10000
+#
Index: trunk/examples/extended/electromagnetic/TestEm7/snr.mac
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm7/snr.mac	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm7/snr.mac	(revision 1230)
@@ -1,3 +1,3 @@
-# $Id: snr.mac,v 1.1 2007/12/19 19:21:41 vnivanch Exp $
+# $Id: snr.mac,v 1.3 2008/05/08 11:20:50 vnivanch Exp $
 #
 # Macro file for "TestEm7.cc"
@@ -19,6 +19,10 @@
 /testem/det/tallyPosition  5.  0. 0. cm
 #
-/testem/phys/addPhysics  standardNR	# use screened nuclear recoil  
-###/testem/phys/addPhysics  binary	# hadronic physics
+#/testem/phys/addPhysics  emstandard
+#/testem/phys/addPhysics  emstandard_opt2
+#/testem/phys/addPhysics  emstandard_opt3  
+/testem/phys/addPhysics  standardNR	  
+#/testem/phys/addPhysics  standardIG  
+###/testem/phys/addPhysics  binary
 #
 /run/initialize
@@ -40,7 +44,2 @@
 /run/beamOn 1000
 #
-/testem/det/setMat G4_Cu
-/testem/det/update
-/gun/particle kaon+
-/gun/energy 100 MeV
-/run/beamOn 1000
Index: trunk/examples/extended/electromagnetic/TestEm7/src/DetectorConstruction.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm7/src/DetectorConstruction.cc	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm7/src/DetectorConstruction.cc	(revision 1230)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: DetectorConstruction.cc,v 1.8 2007/01/11 15:41:46 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-01-patch-02 $
+// $Id: DetectorConstruction.cc,v 1.10 2008/04/21 13:13:30 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
@@ -45,6 +45,9 @@
 
 #include "G4NistManager.hh"
-
 #include "G4UnitsTable.hh"
+
+#include "G4FieldManager.hh"
+#include "G4TransportationManager.hh"
+#include "G4RunManager.hh" 
 
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
@@ -117,4 +120,11 @@
   Air->AddElement(N, fractionmass=0.7);
   Air->AddElement(O, fractionmass=0.3);
+
+  density     = 1.e-5*g/cm3;
+  pressure    = 2.e-2*bar;
+  temperature = STP_Temperature;  // From PhysicalConstants.h .
+  G4Material* vac = new G4Material( "TechVacuum", density, 1,
+                           kStateGas, temperature, pressure );
+  vac->AddMaterial( Air, 1. );
 
   density     = universe_mean_density;    //from PhysicalConstants.h
@@ -235,4 +245,5 @@
 {
   absorSizeX = value; worldSizeX = 1.2*absorSizeX;
+  G4RunManager::GetRunManager()->GeometryHasBeenModified();
 }
   
@@ -243,4 +254,5 @@
   absorSizeYZ = value; 
   worldSizeYZ = 1.2*absorSizeYZ;
+  G4RunManager::GetRunManager()->GeometryHasBeenModified();
 }  
 
@@ -252,11 +264,14 @@
   G4Material* pttoMaterial =
     G4NistManager::Instance()->FindOrBuildMaterial(materialChoice);
-  if (pttoMaterial) absorMaterial = pttoMaterial;
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
-
-#include "G4FieldManager.hh"
-#include "G4TransportationManager.hh"
+  if (pttoMaterial) {
+    absorMaterial = pttoMaterial;
+    if(lAbsor) {
+      lAbsor->SetMaterial(absorMaterial);
+      G4RunManager::GetRunManager()->PhysicsHasBeenModified();
+    }
+  }
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
 
 void DetectorConstruction::SetMagField(G4double fieldValue)
@@ -285,4 +300,5 @@
 {
   tallySize = value;
+  G4RunManager::GetRunManager()->GeometryHasBeenModified();
 }  
 
@@ -294,5 +310,11 @@
   G4Material* pttoMaterial =
     G4NistManager::Instance()->FindOrBuildMaterial(materialChoice);
-  if (pttoMaterial) tallyMaterial = pttoMaterial;
+  if (pttoMaterial) {
+    tallyMaterial = pttoMaterial;
+    if(lTally) {
+      lTally->SetMaterial(tallyMaterial);
+      G4RunManager::GetRunManager()->PhysicsHasBeenModified();
+    }
+  }
 }
 
@@ -305,14 +327,14 @@
     tallyNumber++;
   }
+  G4RunManager::GetRunManager()->GeometryHasBeenModified();
 }  
 
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
-
-#include "G4RunManager.hh" 
  
 void DetectorConstruction::UpdateGeometry()
 {
-G4RunManager::GetRunManager()->DefineWorldVolume(ConstructVolumes());
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
+  G4RunManager::GetRunManager()->PhysicsHasBeenModified();
+  G4RunManager::GetRunManager()->DefineWorldVolume(ConstructVolumes());
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm7/src/DetectorMessenger.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm7/src/DetectorMessenger.cc	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm7/src/DetectorMessenger.cc	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: DetectorMessenger.cc,v 1.3 2006/06/29 16:58:13 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm7/src/EventAction.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm7/src/EventAction.cc	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm7/src/EventAction.cc	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: EventAction.cc,v 1.4 2006/06/29 16:58:15 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm7/src/EventActionMessenger.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm7/src/EventActionMessenger.cc	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm7/src/EventActionMessenger.cc	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: EventActionMessenger.cc,v 1.4 2006/06/29 16:58:17 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
